#!/bin/bash
# Ugly script to generate MPEG files for archival purposes from zoneminder events
# You may have to change some of these to align with your system where the root of your events images are stored!

archive_dir=/mnt/NAS_SERVER/Security_Camera_Footage/
events_dir=/var/www/html/zm/events/

# initialize variables for nothing and set first pass
DATETOENCODE="nothing"
EVENTPATH="nothing"
PREVDAY="nothing"
VIDEOFN="nothing"
FIRSTPASS="yes"

#Lets make a TO DO list for all the events that includes the first capture image
cd $events_dir
# In my zoneminder config options, I am using EVENT_IMAGE_DIGITS set to 5
# I believe the default is 3 so if this is the case you may need to change the following
# line to look for 001-capture.jpg instead or based on whatever number of digits you use.

find ./ -name "00001-capture.jpg" -print > /tmp/unsortedallevents.txt
sort -n /tmp/unsortedallevents.txt > /tmp/allevents.txt

while read EVENTDIRS
  do
    DATETOENCODE="$(echo $EVENTDIRS |awk -F/ '{print "./"$2"/"$3"/"$4"/"$5}')"
    EVENTPATH="$(echo $EVENTDIRS |awk -F/ '{print "/var/www/html/zm/events/"$2"/"$3"/"$4"/"$5"/"$6"/"$7"/"$8"/"}')"
    FULLEVENTPATH=$EVENTPATH
    FULLEVENTPATH+="%05d-capture.jpg"

    echo -n $DATETOENCODE; echo " DATETOENCODE"
    echo -n $PREVDAY; echo " PREVDAY read in"
    #Determine if this is the first pass and skip this comparison if it is
    if [ "$FIRSTPASS" == "yes" ] || [ "$DATETOENCODE" == "$PREVDAY" ]
    then
     PREVDAY=$DATETOENCODE
     FIRSTPASS="no"
     echo "file '"$FULLEVENTPATH"'" >> /tmp/dirs_to_process
     echo "file '"$FULLEVENTPATH"'"
     # Time to grab another record from the all events file
    else
     echo " " >> /tmp/dirs_to_process
     # Sleep a few seconds before encoding new file
     sleep 4
     VIDEOFN="$(echo $PREVDAY |awk -F/ '{print "20"$3"-"$4"-"$5"_cam_"$2".avi"}')"
     echo "------------------what is in the dir_to_process_file----------"
     cat /tmp/dirs_to_process
     echo "------------------this is the filename and directory to save to --------"
     echo $archive_dir $VIDEOFN
     /usr/local/bin/ffmpeg -nostdin -f concat -i /tmp/dirs_to_process -r 18 -qscale:v 10 -codec mpeg4 /$archive_dir/$VIDEOFN
     rm /tmp/dirs_to_process
     sleep 4
     echo "file '"$FULLEVENTPATH"'" >> /tmp/dirs_to_process
     PREVDAY=$DATETOENCODE
     FIRSTPASS="yes"
    fi

  done < /tmp/allevents.txt